VariableOpeningTime = {};
VariableOpeningTime.modDir = g_currentModDirectory;
-----------
function VariableOpeningTime:getServer()	
	return g_server ~= nil and g_client ~= nil and g_dedicatedServer ~= nil;	
end;

function VariableOpeningTime:getHostServer()	
	if g_currentMission.missionDynamicInfo == nil then return false;end;
	return g_server ~= nil and g_client ~= nil and g_dedicatedServer == nil and g_currentMission.missionDynamicInfo.isMultiplayer;	
end;

function VariableOpeningTime:getSp()	
	return g_server ~= nil and g_client ~= nil and g_dedicatedServer == nil and not g_currentMission.missionDynamicInfo.isMultiplayer;	
end;

function VariableOpeningTime:getClient()	
	return g_server == nil and g_client ~= nil and g_dedicatedServer == nil and g_currentMission.missionDynamicInfo.isMultiplayer;	
end;

function VariableOpeningTime:canProcess(typ)
	if typ == "server" then
		return VariableOpeningTime:getServer() or VariableOpeningTime:getHostServer();
	elseif typ == "client" then
		return (VariableOpeningTime:getSp() or VariableOpeningTime:getHostServer()) and not VariableOpeningTime:getServer();
	end;
end;
-----------

VariableOpeningTime.version = 1.1; --for other Mods zum abgleichen ob functionen zur verfügung stehen
VariableOpeningTime.maxStartEndTime = 4; --wieviele Zeiten hinterlegt werden können (beachten wenn man das zu hoch setzt wird die Anzeige in der Produktionsübersicht aus dem Monitorrand raus laufen)  ! gegebenfalls später mal neu berechnen und prüfen und dann einen Zeilenumbruch machen  !
VariableOpeningTime.ingameProductionFrame = {currenTime=false,title=false,titlePosY=0,titelPosX=0,titleWidth=0,titleHeight=0,openingTime=false,openingTimePosY=0,openingTimePosX=0,openingTimeWidth=0,openingTimeHeight=0,info=false}; --interne frame ingame Menü Werte für den Mod
VariableOpeningTime.ingameBoxFrames = {visible=false,radius=5,objects={},hudBox={}}; --interne frame Box player onFoot Werte für den Mod
VariableOpeningTime.objects = {};
VariableOpeningTime.isMapLoaded = false;
VariableOpeningTime.testString = {};
VariableOpeningTime.currentTime = 0;
source(VariableOpeningTime.modDir.."votRegister.lua");
source(VariableOpeningTime.modDir.."animated/votAnimatedLoad.lua");
source(VariableOpeningTime.modDir.."animated/votFenceLoad.lua");
source(VariableOpeningTime.modDir.."production/votProductionLoad.lua");
source(VariableOpeningTime.modDir.."beehive/votBeehiveLoad.lua");
source(VariableOpeningTime.modDir.."sellingStation/votSellingStationLoad.lua");
source(VariableOpeningTime.modDir.."buyingStation/votBuyingStationLoad.lua");


source(VariableOpeningTime.modDir.."votSetGet.lua");
source(VariableOpeningTime.modDir.."votLoad.lua");
source(VariableOpeningTime.modDir.."votUpdate.lua");

VariableOpeningTime.metadata = {
	interface = " FS22 ...",
	title = "VariableOpeningTime",
	notes = " Variable Betriebs/Öffnungszeiten für Produktionen/Tore und mehr",
	author = " (by [ALM] Akita83/HappyLooser)",
	info = "Gemeinschafts-Project",
	version = " v1.13 beta",
	datum = " 19.04.2023",
	web = " https://www.lpg-ackendorf.de/",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe: https://www.lpg-ackendorf.de/"
};

local votTest = true;
function VariableOpeningTime:loadMap()
	print("---loading ".. tostring(VariableOpeningTime.metadata.title).. tostring(VariableOpeningTime.metadata.version).. tostring(VariableOpeningTime.metadata.author).. "---")
	if VariableOpeningTime:canProcess("client") then source(VariableOpeningTime.modDir.."_hl.lua");source(VariableOpeningTime.modDir.."mohFeatures/votTotalState.lua");end;	
	Mission00.onStartMission = Utils.appendedFunction(Mission00.onStartMission, VariableOpeningTime.onStartMission);	
	votLoad:placeable();
	if votSellingStationLoad ~= nil then votSellingStationLoad:object();end;
	if votBuyingStationLoad ~= nil then votBuyingStationLoad:object();end;
	if votAnimatedLoad ~= nil then votAnimatedLoad:object();end;
	if votFenceLoad ~= nil then votFenceLoad:object();end;
	if votProductionLoad ~= nil then votProductionLoad:object();end;	
end;

function VariableOpeningTime:onStartMission() --nur auf Clients und Hoste Server ausführen	
	if VariableOpeningTime:getServer() then return;end;	
	g_currentMission.player.hudUpdater.showVotObject = {};
	votLoad:onStartMission();
	if votProductionLoad ~= nil then votProductionLoad:onStartMission();end;
	if votBeehiveLoad ~= nil then votBeehiveLoad:onStartMission();end;
	if votAnimatedLoad ~= nil then votAnimatedLoad:onStartMission();end;
	if votFenceLoad ~= nil then votFenceLoad:onStartMission();end;
	if votSellingStationLoad ~= nil then votSellingStationLoad:onStartMission();end;
	if votBuyingStationLoad ~= nil then votBuyingStationLoad:onStartMission();end;
	if g_currentMission.multiOverlayV4 == nil then VariableOpeningTime.objects = {};end;
end;

function VariableOpeningTime:update(dt)	
	if not VariableOpeningTime.isMapLoaded then votLoad:onCreateMapObject();VariableOpeningTime.isMapLoaded = true;end;
	if VariableOpeningTime:getServer() then return;end;	
	VariableOpeningTime.currentTime = votSetGet:getCurrentTime();	
end;

function VariableOpeningTime:draw()
	if VariableOpeningTime:getServer() then return;end;
	if g_currentMission.hl.getIngameMap() or g_currentMission.hl.getFullSize(true, true) then return;end;	
	if VariableOpeningTime.ingameBoxFrames.hudBox ~= nil then
		for hud, box in pairs(VariableOpeningTime.ingameBoxFrames.hudBox) do
			if box ~= nil and box.visible then
				votUpdate:objectHudBoxOwnShowInfo(hud, box);			
			end;
		end; 
	end;
	if #VariableOpeningTime.testString > 0 then
		setTextBold(true);		
		for a=1, #VariableOpeningTime.testString do
			local posY = 0.25-(a/100);
			renderText(0.35, posY, 0.010, "-S ".. tostring(a).. "- ".. tostring(VariableOpeningTime.testString[a]));
		end;
	end;
end;
addModEventListener(VariableOpeningTime);