votTotalStateOutput = {};

function votTotalStateOutput:load(slotTable)	
	local playerFarmId = g_currentMission.player.farmId;
	local lineTable = {line={}};
	local isLineTable = nil;
	local color = "txtOutputTitle";
	local iconColor = "darkGray";
	local openingTimeBlink = false;
	--title
	lineTable.line[#lineTable.line+1] = {};
	isLineTable = lineTable.line[#lineTable.line];	
	isLineTable.txt = {};
	isLineTable.txt[1] = {};
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].slotColor = color;					
	isLineTable.txt[1].txt = g_i18n:getText("ui_operatingHours").. "/".. g_i18n:getText("vot_WorkingHours").. "/".. g_i18n:getText("vot_OpeningTime");	
	isLineTable.txt[1].alignment = 2;	
	--title
	if next(votTotalState.values.objects) ~= nil then
		function setGroupName(typ, objects)			
			local moreTxt = "";
			if objects ~= nil and type(objects) == "table" and #objects > 0 then
				moreTxt = " (".. tostring(#objects).. ")";
			end;
			lineTable.line[#lineTable.line+1] = {};
			isLineTable = lineTable.line[#lineTable.line];	
			isLineTable.txt = {};
			isLineTable.txt[1] = {};
			isLineTable.txt[1].bold = true;
			isLineTable.txt[1].slotColor = "txtOutputTitle";
			if typ == "sellingStation" then 
				isLineTable.txt[1].txt = tostring(g_i18n:getText("construction_tab_sellingPoints", "SellingStations")).. tostring(moreTxt);
			elseif typ == "buyingStation" then 
				isLineTable.txt[1].txt = tostring(g_i18n:getText("station_us_shoppingMall", "BuyingStations")).. tostring(moreTxt);
			elseif typ == "productionPoint" then 
				isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_productions_production", "Productions")).. tostring(moreTxt);
			elseif typ == "beehive" then 
				isLineTable.txt[1].txt = tostring(g_i18n:getText("category_beeHives", "Beehives")).. tostring(moreTxt);
			elseif typ == "animatedObject" or typ == "animatedMapObject" then
				isLineTable.txt[1].txt = tostring(g_i18n:getText("shopItem_fenceGate", "Doors")).. tostring(moreTxt);
			elseif typ == "animatedFenceObject" then
				isLineTable.txt[1].txt = tostring(g_i18n:getText("shopItem_fence", "Fences")).. tostring(moreTxt);
			else
				isLineTable.txt[1].txt = "Unknown";
			end;
			local buttonName = "buttonDown";
			local iconColor = "gray";
			if votTotalState.values.group[typ] then iconColor="green";end;
			if moreTxt:len() > 0 then
				isLineTable.txt[1].icon = {before={},after={}};
				isLineTable.txt[1].icon.before[1] = {name=buttonName, color=iconColor, settingButton=true, callback={[1]=votTotalStateOutput.clickGroupName}, ownTable={typ}};
			end;
		end;
		for typ, objects in pairs(votTotalState.values.objects) do
			setGroupName(typ, objects);
			if votTotalState.values.group[typ] then
				if objects ~= nil and type(objects) == "table" then					
					for a=1, #objects do
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];	
						isLineTable.txt = {};
						isLineTable.txt[1] = {};						
						isLineTable.txt[1].color = "ls22";
						isLineTable.txt[1].txt = objects[a].name;
						isLineTable.txt[2] = {};						
						local openingTxt = "";
						function setOpeningTxt()							
							function infoWhen(txt)
								if objects[a].infoWhenVisible then
									if not g_currentMission.hl.runsTimer("1sec", true) then
										if objects[a].isOpening then color = "orangeRed";else color = "green";end;
										return objects[a].infoWhen;
									end;
								end;
								return txt;								
							end;
							function replaceTxt(txt)
								local newTxt = "";
								local txtWidth = getTextWidth(slotTable.txtSize, utf8Substr(txt, 0));
								local newTxtWidth = 0;
								while newTxtWidth < txtWidth do
									newTxt = newTxt.. " ";									
									newTxtWidth = getTextWidth(slotTable.txtSize, utf8Substr(newTxt, 0));
								end;
								return newTxt;
							end;
							function formatBlinkOpeningTime(txtLine, openingTxt)
								local txt = openingTxt;
								if openingTimeBlink and #objects[a].txt > 1 then 
									if not g_currentMission.hl.runsTimer("1sec", true) then
										if objects[a].isOpening then
											if objects[a].activeOpeningTime == txtLine then
												txt = replaceTxt(txt);										
											end;										
										else
											if objects[a].nextActiveOpeningTime == txtLine then
												txt = replaceTxt(txt);										
											end;										
										end;
									end;
								end;								
								return txt;
							end;							
							for t=1, #objects[a].txt do								
								local tempOpeningTxt = formatBlinkOpeningTime(t, objects[a].txt[t])
								if openingTxt:len() > 0 then
									openingTxt = openingTxt.. " / ".. tempOpeningTxt;
								else
									openingTxt = tempOpeningTxt;
								end;
								if t == #objects[a].txt then
									local formatClock = string.format(g_i18n:getText("vot_ClockTime"), tostring("-"), tostring("-"));
									openingTxt = openingTxt.. " ".. string.gsub(formatClock, "---", "");									
								end;
							end;													
							if objects[a].isOpening then
								color = "green";
							else
								color = "yellow";
							end;
							openingTxt = infoWhen(openingTxt);	
						end;
						setOpeningTxt();
						isLineTable.txt[2].color = color;
						isLineTable.txt[2].txt = openingTxt;
						isLineTable.txt[2].alignment = 3;
					end;
				end;
			end;
		end;
	else
		--not found OpeningTime Objects--
		lineTable.line[#lineTable.line+1] = {};
		isLineTable = lineTable.line[#lineTable.line];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].slotColor = "settingAlreadyExistsCmd";					
		isLineTable.txt[1].txt = g_i18n:getText("ui_gameComputerNoCartridges").. " (".. g_i18n:getText("ui_operatingHours").. "/....)";
		--not found OpeningTime Objects--
	end;
	--help icon--
	if slotTable ~= nil and slotTable.help.outputOn and lineTable.line[1] ~= nil and lineTable.line[1].txt ~= nil and lineTable.line[1].txt[1] ~= nil then		
		if lineTable.line[1].txt[1].icon == nil then lineTable.line[1].txt[1].icon = {before={},after={}};
			lineTable.line[1].txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=votTotalStateOutput.clickTitleHelpTxt}};
		else
			table.insert(lineTable.line[1].txt[1].icon.before, 1, {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=votTotalStateOutput.clickTitleHelpTxt}});
		end;
	end;
	--help icon--
	votTotalStateOutput.output = lineTable;
end;

function votTotalStateOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" then return false;end;
	g_currentMission.multiOverlayV4.moduleFunction.setActiveRunningModul( {modName="variableOpeningTime", modulName="votTotalState" } );	
	votTotalStateOutput:load(args.slotTable);
	return votTotalStateOutput.output;
end;

function votTotalStateOutput.clickGroupName(args)
	if args == nil or type(args) ~= "table" and args.ownTable ~= nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and votTotalState.values.group[args.ownTable[1]] ~= nil then
			votTotalState.values.group[args.ownTable[1]] = not votTotalState.values.group[args.ownTable[1]];
		end;
	end;
end;

function votTotalStateOutput.clickTitleHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		g_currentMission.multiOverlayV4.moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		g_currentMission.multiOverlayV4.moSetGetOverlays.infoHelpBox.help.titel = "VariableOpeningTime";
		g_currentMission.multiOverlayV4.moSetGetOverlays.infoHelpBox.help.txt = "Click Icons or Text for more Info/Sort and ... (Mouse Click Left/Right/Middle)";
	end;
end;
if g_currentMission.multiOverlayV4 ~= nil then
	g_currentMission.multiOverlayV4.moduleFunction.addActiveRunningModul( {modName="variableOpeningTime", modulName="votTotalState" } );
end;