votLoad = {}; --global

function votLoad:onStartMission()	
	local env = getfenv(0);
	if env["FS22_A_ProductionRevamp"] ~= nil and env["FS22_A_ProductionRevamp"].RevampSpawner ~= nil then 		
		ProductionPointActivatable.run = Utils.overwrittenFunction(ProductionPointActivatable.run, votLoad.revampSpawnerRun);
	end;
end;

function votLoad:placeable() --Beim starten in alle Platzierbaren Objecte mit rein setzen wo startTime und endTime in der XML hinterlegt wurden und die wir unterstützen
    votOldLoadPlaceable = Placeable.load;
    Placeable.load = function(self, placeableData, asyncCallbackFunction, asyncCallbackObject, asyncCallbackArguments)
        local isOkay, result = pcall(votOldLoadPlaceable, self, placeableData, asyncCallbackFunction, asyncCallbackObject, asyncCallbackArguments)
        if isOkay and self ~= nil and self.xmlFile ~= nil and self.votOpeningTime == nil then
			--print("------TypeName: ".. tostring(self.typeName))
			--print("xmlFilename placeable: ".. tostring(self.configFileName))
			votBeehiveLoad:object(self, self.xmlFile);			
			return result;
        end;
		return result;
    end;
end;

function votLoad:onCreateMapObject() --Beim starten in alle verbauten Map Objecte mit rein setzen wo startTime und endTime in der XML hinterlegt wurden (alte LS 15/17/19 function by MultiOverlayV2 Hud) 
	if g_currentMission ~= nil and g_currentMission.onCreateObjectSystem ~= nil and g_currentMission.onCreateObjectSystem.objects ~= nil and #g_currentMission.onCreateObjectSystem.objects > 0 then		
		local xmlFilename = nil;
		local xmlFile = nil;		
		for a=1, #g_currentMission.onCreateObjectSystem.objects do			
			if g_currentMission.onCreateObjectSystem.objects[a].xmlFilename ~= nil then				
				--print("xmlFilename onCreateMapObject: ".. tostring(g_currentMission.onCreateObjectSystem.objects[a].xmlFilename))
				--AnimatedMapObject--
				if g_currentMission.onCreateObjectSystem.objects[a].openingHours ~= nil and g_currentMission.onCreateObjectSystem.objects[a].animatedObjectDirtyFlag ~= nil then
					if xmlFilename ~= g_currentMission.onCreateObjectSystem.objects[a].xmlFilename then
						xmlFilename = g_currentMission.onCreateObjectSystem.objects[a].xmlFilename;
						if xmlFile ~= nil then XMLFile.delete(xmlFile);end;
						xmlFile = XMLFile.load("AnimatedObject", xmlFilename, AnimatedMapObject.xmlSchema);
					end;
					if xmlFile ~= nil then votAnimatedLoad:mapObject(g_currentMission.onCreateObjectSystem.objects[a], xmlFile);end;				
				end;
				--AnimatedMapObject--
			end;
		end;
		if xmlFile ~= nil then XMLFile.delete(xmlFile);end;	
	end;		
end;

function votLoad.onInfoTriggerCallback(self, triggerId, otherId, onEnter, onLeave, onStay) --brauchen wir für bestimmte Objecte an die wir sonst nicht mehr dran kommen ohne etliche abfragen	
	if g_currentMission ~= nil and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then			
		local isVotObject, votObject = votSetGet:getVotObject(self, true);
		if isVotObject and votObject ~= nil then
			local typ = votObject.votTyp.. "_".. tostring(votObject.rootNode or votObject.nodeId);			
			if VariableOpeningTime.ingameBoxFrames.hudBox[typ] ~= nil then
				if onEnter or onStay then			
					VariableOpeningTime.ingameBoxFrames.hudBox[typ].object = votObject; --change				
					VariableOpeningTime.ingameBoxFrames.hudBox[typ].visible = true;								
				elseif onLeave then			
					VariableOpeningTime.ingameBoxFrames.hudBox[typ].visible = false;							
				end;
			else
				votSetGet:generateIngameOpeningTimeFrameBoxChange(votObject, typ); --change
			end;	
		end;		
	end;	
end;
PlaceableInfoTrigger.onInfoTriggerCallback = Utils.appendedFunction(PlaceableInfoTrigger.onInfoTriggerCallback, votLoad.onInfoTriggerCallback);

function votLoad.playerHudUpdate(self, dt, x, y, z, rotY)
	if g_currentMission ~= nil then
		local showVotObject = g_currentMission.player.hudUpdater.showVotObject;
		if showVotObject ~= nil then		
			for key, value in pairs(showVotObject) do						
				if value ~= nil then
					if VariableOpeningTime.ingameBoxFrames.hudBox[value.typ] ~= nil then					
						if g_currentMission.controlledVehicle == nil and votSetGet:getDistance(nil, value.currentRaycastTarget, 10, false, false) then									
							VariableOpeningTime.ingameBoxFrames.hudBox[value.typ].visible = true;
						else						
							showVotObject[key] = nil;
							VariableOpeningTime.ingameBoxFrames.hudBox[value.typ].visible = false;						
						end;				
					end;
				end;
			end;
		end;
	end;
end;
PlayerHUDUpdater.update = Utils.prependedFunction(PlayerHUDUpdater.update, votLoad.playerHudUpdate);

function votLoad.playerHudUpdateRaycastObject(self)	
	if g_currentMission ~= nil and g_currentMission.player ~= nil and g_currentMission.player.hudUpdater ~= nil then
		local showVotObject = g_currentMission.player.hudUpdater.showVotObject;
		local currentRaycastTarget = self.currentRaycastTarget;
		if showVotObject ~= nil then
			local votObject = nil;
			local votObjectId = nil;		
			function setShowVotOject()			
				if votObjectId ~= nil and votObject ~= nil then
					if showVotObject[votObjectId] == nil then 
						local typ = votObject.votTyp.. "_".. tostring(votObjectId);
						showVotObject[votObjectId] = {votObjectId=votObjectId,currentRaycastTarget=currentRaycastTarget,typ=typ};					
						if votSetGet:getDistance(nil, currentRaycastTarget, 10, false, false) then					
							if VariableOpeningTime.ingameBoxFrames.hudBox[typ] ~= nil then								
								VariableOpeningTime.ingameBoxFrames.hudBox[typ].visible = true;				
							else
								votSetGet:generateIngameOpeningTimeFrameBoxChange(votObject, typ); --change
							end;
						end;
					end;
				end;
			end;		
			for key, value in pairs(showVotObject) do			
				if value ~= nil then				
					if g_currentMission.controlledVehicle ~= nil or not votSetGet:getDistance(nil, value.currentRaycastTarget, 10, false, false) then
						if VariableOpeningTime.ingameBoxFrames.hudBox[value.typ] ~= nil then								
							VariableOpeningTime.ingameBoxFrames.hudBox[value.typ].visible = false;							
						end;					
						showVotObject[key] = nil;
					end;
				end;
			end;		
			if currentRaycastTarget ~= nil and g_currentMission.controlledVehicle == nil then
				local object = g_currentMission:getNodeObject(self.currentRaycastTarget);
				votObject = nil;
				if object ~= nil then
					if object.votOpeningTime ~= nil and #object.votOpeningTime > 0 then
						votObject = object;
						votObjectId = object.rootNode or object.nodeId;
						setShowVotOject();				
					else
						if object.spec_sellingStation ~= nil and object.spec_sellingStation.sellingStation ~= nil then
							votObject = object.spec_sellingStation.sellingStation;
							if votObject ~= nil and votObject.votOpeningTime ~= nil and #votObject.votOpeningTime > 0 then
								votObjectId = votObject.rootNode or votObject.nodeId;
								setShowVotOject();						
							end;
						end;
						if object.spec_buyingStation ~= nil and object.spec_buyingStation.buyingStation ~= nil then
							votObject = object.spec_buyingStation.buyingStation;
							if votObject ~= nil and votObject.votOpeningTime ~= nil and #votObject.votOpeningTime > 0 then
								votObjectId = votObject.rootNode or votObject.nodeId;						
								setShowVotOject();						
							end;
						end;
					end;
				end;
			end;
		end;
	end;	
end;
PlayerHUDUpdater.updateRaycastObject = Utils.prependedFunction(PlayerHUDUpdater.updateRaycastObject, votLoad.playerHudUpdateRaycastObject);

function votLoad.getIsFillableObjectAvailableLoadTrigger(self, superFunc)	
	local isVotObject, votObject = votSetGet:getVotObject(self.source, false);	
	if isVotObject and votObject ~= nil then
		if not votObject.votLoadingIfClosed then
			votSetGet:votIsOpening(votObject); --change
			if not votObject.votIsOpening then
				if not VariableOpeningTime:getServer() then
					local isOkay, txt = votSetGet:getClosedText(votObject);
					if g_currentMission ~= nil and isOkay and votSetGet:getDistance(self.source, nil, 30, true, true) then
						g_currentMission:showBlinkingWarning(tostring(txt), 2000, 1);					
					end;
				end;
				return false;
			end;
		end;
	end;
	return superFunc(self);
end;

function votLoad.getIsToolTypeAllowedUnloadTrigger(self, superFunc, toolType)
	local isVotObject, votObject = votSetGet:getVotObject(self.target, false);	
	if isVotObject and votObject ~= nil then
		if not votObject.votUnloadingIfClosed then
			votSetGet:votIsOpening(votObject); --change
			if not votObject.votIsOpening then
				if not VariableOpeningTime:getServer() then
					local isOkay, txt = votSetGet:getClosedText(votObject);
					if g_currentMission ~= nil and isOkay and votSetGet:getDistance(self.target, nil, 30, true, true) then
						g_currentMission:showBlinkingWarning(tostring(txt), 2000, 1);					
					end;
				end;
				return false;
			end;
		end;
	end;	
	return superFunc(self, toolType);
end;

function votLoad.getIsFillTypeAllowedUnloadTrigger(self, superFunc, fillType)
	local isVotObject, votObject = votSetGet:getVotObject(self.target, false);	
	if isVotObject and votObject ~= nil then
		if not votObject.votUnloadingIfClosed then
			votSetGet:votIsOpening(votObject); --change
			if not votObject.votIsOpening then
				if not VariableOpeningTime:getServer() then
					local isOkay, txt = votSetGet:getClosedText(votObject);
					if g_currentMission ~= nil and isOkay and votSetGet:getDistance(self.target, nil, 30, true, true) then
						g_currentMission:showBlinkingWarning(tostring(txt), 2000, 1);					
					end;
				end;
				return false;
			end;
		end;
	end;
	return superFunc(self, fillType);
end;

function votLoad.woodSellTriggerCallback(self, triggerId, otherActorId, onEnter, onLeave, onStay, otherShapeId)
	if g_currentMission ~= nil and g_currentMission.player ~= nil and otherActorId == g_currentMission.player.rootNode then
		if self.target ~= nil then
			local isVotObject, votObject = votSetGet:getVotObject(self.target.target, false);			
			if isVotObject and votObject ~= nil then				
				if not votObject.votIsOpening then
					self.isManualSellingActive = false;
					if onEnter or onStay then
						if not VariableOpeningTime:getServer() then
							local isOkay, txt = votSetGet:getClosedText(votObject);
							if isOkay and votSetGet:getDistance(nil, triggerId, 20, true, false) then
								g_currentMission:showBlinkingWarning(tostring(txt), 2000, 1);
							end;
						end;
					end;
				else
					self.isManualSellingActive = true;
				end;				
			end;
		end;
	end;
end;

function votLoad.getDischargeNotAllowedWarning(self, superFunc, dischargeNode)
	if dischargeNode.dischargeHitObject ~= nil and dischargeNode.dischargeHitObject.target ~= nil and dischargeNode.dischargeHitObject.target.votOpeningTime ~= nil and not dischargeNode.dischargeHitObject.target.votIsOpening then
		local isOkay, txt = votSetGet:getClosedText(dischargeNode.dischargeHitObject.target);
		if isOkay then			
			return tostring(txt);		
		end;	
	end;	
	return superFunc(self, dischargeNode);
end;

function votLoad.revampSpawnerRun(self, superFunc)
	local isVotObject, votObject = votSetGet:getVotObject(self.productionPoint, false);	
	if isVotObject and votObject ~= nil then
		local ownerFarmId = self.productionPoint:getOwnerFarmId();
		if ownerFarmId ~= AccessHandler.EVERYONE then
			if not votObject.votIsOpening then
				self.productionPoint:openMenu();
				return;
			end;
		end;
	end;
	return superFunc(self);
end;
Dischargeable.getDischargeNotAllowedWarning = Utils.overwrittenFunction(Dischargeable.getDischargeNotAllowedWarning, votLoad.getDischargeNotAllowedWarning);
WoodUnloadTrigger.woodSellTriggerCallback = Utils.prependedFunction(WoodUnloadTrigger.woodSellTriggerCallback, votLoad.woodSellTriggerCallback);
UnloadTrigger.getIsToolTypeAllowed = Utils.overwrittenFunction(UnloadTrigger.getIsToolTypeAllowed, votLoad.getIsToolTypeAllowedUnloadTrigger);
UnloadTrigger.getIsFillTypeAllowed = Utils.overwrittenFunction(UnloadTrigger.getIsFillTypeAllowed, votLoad.getIsFillTypeAllowedUnloadTrigger);
LoadTrigger.getIsFillableObjectAvailable = Utils.overwrittenFunction(LoadTrigger.getIsFillableObjectAvailable, votLoad.getIsFillableObjectAvailableLoadTrigger);




