votUpdate = {}; --global

function votUpdate:replaceProductionPointStatus(object, infoTable)
	if #object.activeProductions > 0 then				
		function replaceStatus(productionName)										
			if infoTable ~= nil and #infoTable > 0 then
				for t=1, #infoTable do
					if infoTable[t].title == productionName and type(infoTable[t].text) == "string" then 
						infoTable[t].text = g_i18n:getText("vot_Closed", "closed");
						break;
					end;
				end;
			end;
		end;					
		local activeProduction = nil;
		for i = 1, #object.activeProductions do
			activeProduction = object.activeProductions[i]
			local productionName = activeProduction.name or g_fillTypeManager:getFillTypeByIndex(activeProduction.primaryProductFillType).title;
			replaceStatus(productionName);					
		end;				
	end;
end;

function votUpdate:showInfo(object, infoTable, ownShowInfo, objectName) --nur auf Client und Host Server ausführen	
	votSetGet:votIsOpening(object);
	if VariableOpeningTime:getServer() then return;end;
	local isVotObject = true;
	--if VariableOpeningTime:canProcess("client") then isVotObject = votSetGet:votIsOpening(object);end; --manuel auf Clients anstupsen weil der Status nicht vom Server übertragen wird
	if isVotObject ~= nil then		
		local setOneLine = false;		
		local title = Utils.getNoNil(g_i18n:getText("vot_WorkingHours"), "Workinghours"); --object.votFrameText.title;
		if object.votTyp == "animatedObject" or object.votTyp == "animatedMapObject" then title = g_i18n:getText("vot_OpeningTime", "OpeningTime");end;		
		local color = g_currentMission.hl.getColor("green", true);
		for a=1, #object.votOpeningTime do				
			color = g_currentMission.hl.getColor("green", true);
			local moreOpeningTxt = "";
			local moreNotOpeningTxt = "";
			local accentuate = false;
			local text = string.format(g_i18n:getText("vot_ClockTime"), tostring(object.votOpeningTime[a].startTime), tostring(object.votOpeningTime[a].endTime));
			if object.votOtherMod.active then 
				title = object.votOtherMod.title;text=object.votOtherMod.text;
				setOneLine=true;color=nil;		
			else
				if object.votIsOpening and a == object.votActiveOpeningTime then 
					if ownShowInfo then 
						color = g_currentMission.hl.getColor("green", true);
						accentuate = true;
					else
						moreOpeningTxt = ">>  ";
					end;
				end;				
				if not object.votIsOpening then					
					color = nil;
					if a == object.votNextActiveOpeningTime then 
						moreNotOpeningTxt = "  <<";
					end;
				end;
			end;
			table.insert(infoTable, a, {					
				title = tostring(a).. ".".. title.. tostring(moreNotOpeningTxt);
				accentuate = accentuate;
				accentuateColor = color;
				text = tostring(moreOpeningTxt).. text;	
			});
			if setOneLine then break;end;
		end;		
		if not ownShowInfo and not object.votIsOpening and object.votTyp == "productionPoint" then votUpdate:replaceProductionPointStatus(object, infoTable);end;
		local moreTxt = "";		
		if not setOneLine then
			if not object.votIsOpening then moreTxt = g_i18n:getText("vot_Closed", "closed");else moreTxt = g_i18n:getText("vot_Opened", "opened");end;
		end;
		if ownShowInfo then	
			if object.votIsOpening then 
				color = g_currentMission.hl.getColor("khaki", true);
			else 
				color = g_currentMission.hl.getColor("orangeRed", true);
			end;
		else 
			color = nil;
		end;
		table.insert(infoTable, 1, {
			title = Utils.getNoNil(g_i18n:getText("ui_operatingHours")).. " (".. tostring(#object.votOpeningTime).. ")";
			accentuate = true;
			accentuateColor = color;
			text = moreTxt;
		})
		if not setOneLine and object.votNextHour.infoWhen.time > 0 then				
			if object.votNextHour.infoWhen.visible then
				color = g_currentMission.hl.getColor("orangeRed", true);
				if not object.votIsOpening then color = g_currentMission.hl.getColor("green", true);end;
				table.insert(infoTable, 2, {
				title = object.votNextHour.infoWhen.title;
				accentuate = true;
				accentuateColor = color;									
				text = object.votNextHour.infoWhen.text;		
			})				
			end;		
		end;
		if objectName ~= nil and objectName:len() > 0 and ownShowInfo then
			color = g_currentMission.hl.getColor("ls22", true);
			table.insert(infoTable, 1, {
				title = tostring(objectName);
				accentuate = true;
				accentuateColor = color;
				text = "";
			})
		end;
	end;
	return infoTable;
end;

function votUpdate:objectHudBoxOwnShowInfo(hud, box)
	box:clear();
	local canVisible = false;		
	if box.object ~= nil then		
		if (box.object.votOpeningTime ~= nil and #box.object.votOpeningTime > 0 and box.object.votShowInfo) then			
			if string.find(hud, "sellingStation_") and box.object.votTyp == "sellingStation" then					
				canVisible = votSellingStation:ownShowInfo(box);					
			elseif string.find(hud, "buyingStation_") and box.object.votTyp == "buyingStation" then					
				canVisible = votBuyingStation:ownShowInfo(box);
			elseif string.find(hud, "beehive_") and box.object.votTyp == "beehive" then
				canVisible = votBeehive:ownShowInfo(box);
			elseif string.find(hud, "productionPoint_") and box.object.votTyp == "productionPoint" then				
				canVisible = votProduction:ownShowInfo(box);
			elseif (string.find(hud, "animatedObject_") or string.find(hud, "animatedMapObject_") or string.find(hud, "animatedFenceObject_")) and (box.object.votTyp == "animatedObject" or box.object.votTyp == "animatedMapObject" or box.object.votTyp == "animatedFenceObject") then
				canVisible = votAnimated:ownShowInfo(box);
			end;
		end;		
	end;
	box.visible = canVisible;
	box:showNextFrame();	
end;